Index: /trunk/tester/resultspage.tcl
===================================================================
--- /trunk/tester/resultspage.tcl	(revision 2026)
+++ /trunk/tester/resultspage.tcl	(revision 2027)
@@ -18,4 +18,6 @@
     itk_option define -textfont textFont Font ""
     itk_option define -boldtextfont boldTextFont Font ""
+    itk_option define -clearcommand clearCommand ClearCommand ""
+    itk_option define -appname appName AppName ""
 
     constructor {args} { # defined below }
@@ -25,4 +27,5 @@
     public method clear {}
     public method download {option args}
+    public method resultset {}
 
     protected method _plot {args}
@@ -90,5 +93,5 @@
 
     if {[Rappture::filexfer::enabled]} {
-        Rappture::Tooltop::for $itk_component(download) "Downloads the current result to a new web browser window on your desktop.  From there, you can easily print or save results.
+        Rappture::Tooltip::for $itk_component(download) "Downloads the current result to a new web browser window on your desktop.  From there, you can easily print or save results.
 
 NOTE:  Your web browser must allow pop-ups from this site.  If your output does not appear, look for a 'pop-up blocked' message and enable pop-ups."
@@ -114,7 +117,4 @@
             -clearcommand [itcl::code $this clear] \
             -settingscommand [itcl::code $this _plot] 
-    } {
-        usual
-        keep -promptcommand
     }
     pack $itk_component(resultset) -expand yes -fill both
@@ -129,5 +129,4 @@
         itcl::delete object $obj
     }
-    # TODO: after cancel [itcl::code $this simulate] ???
 }
   
@@ -228,5 +227,6 @@
                 set f [$itk_component(resultpages) page $page]
                 set item [$itk_component(resultselector) value]
-                set result [$f.rviewer download now $widget $_appName $item]
+                set result [$f.rviewer download now $widget \
+                    $itk_option(-appname) $item]
                 if { $result == "" } {
                     return;                # User cancelled the download.
@@ -260,6 +260,4 @@
 
 itcl::body Rappture::ResultsPage::load {xmlobj} {
-    # TODO: only show the last result? then clear first 
-
     # look for all output.load children and load them first
     # each run.xml is loaded as a previous simulation.
@@ -439,7 +437,9 @@
     #set _pages 0
 
-    # TODO: _simState on
-    # TODO: _fixSimControl
-    # TODO: _reset
+    # Invoke -clearcommand option
+    if {[string length $itk_option(-clearcommand)] > 0} {
+        uplevel #0 $itk_option(-clearcommand)
+    }
+
 }
 
@@ -539,2 +539,6 @@
 }
 
+itcl::body Rappture::ResultsPage::resultset {} {
+    return $itk_component(resultset)
+}
+
Index: /trunk/tester/tester.tcl
===================================================================
--- /trunk/tester/tester.tcl	(revision 2026)
+++ /trunk/tester/tester.tcl	(revision 2027)
@@ -72,5 +72,5 @@
     -selectcommand Rappture::Tester::selectionHandler]
 .pw add [frame .right]
-Rappture::Tester::TestView .right.view -toolxml $params(-tool)
+Rappture::Tester::TestView .right.view
 button .right.regoldenize -text "Regoldenize" -state disabled \
     -command Rappture::Tester::regoldenize
@@ -78,4 +78,5 @@
 pack .right.view -side bottom -expand yes -fill both
 pack .pw -expand yes -fill both
+set lastsel ""
 
 # TODO: Handle resizing better
@@ -91,10 +92,14 @@
 # ----------------------------------------------------------------------
 proc Rappture::Tester::selectionHandler {args} {
+    global lastsel
     set test [.tree getTest]
-    .right.view configure -test $test 
-    if {$test != "" && [$test hasRan] && [$test getResult] != "Error"} {
-        .right.regoldenize configure -state normal
-    } else {
-        .right.regoldenize configure -state disabled
+    if {$test != $lastsel} {
+        .right.view configure -test $test 
+        if {$test != "" && [$test hasRan] && [$test getResult] != "Error"} {
+            .right.regoldenize configure -state normal
+        } else {
+            .right.regoldenize configure -state disabled
+        }
+        set lastsel $test
     }
 }
Index: /trunk/tester/testview.tcl
===================================================================
--- /trunk/tester/testview.tcl	(revision 2026)
+++ /trunk/tester/testview.tcl	(revision 2027)
@@ -4,7 +4,6 @@
 #  Entire right hand side of the regression tester.  Displays the
 #  golden test results, and compares them to the new results if the test
-#  has been ran.  The new version's tool.xml must be provided through the
-#  -toolxml configuration option, and the -test configuration option is
-#  used to provide a Test object to display.
+#  has been ran.  The -test configuration option is used to provide a
+#  Test object to display.
 # ======================================================================
 #  AUTHOR:  Ben Rafferty, Purdue University
@@ -32,7 +31,6 @@
 
     public variable test 
-    public variable toolxml
-
-    constructor {toolxml args} { #defined later }
+
+    constructor {args} { #defined later }
 
     protected method reset 
@@ -90,17 +88,4 @@
     eval itk_initialize $args
 
-    if {$toolxml == "" } {
-        error "no -toolxml configuration option given."
-    }
-}
-
-# --------------------------------------------------------------------
-# Create a new Tool object if -toolxml option is changed.  Also
-# refresh the display by calling the configbody for the -test option.
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Tester::TestView::toolxml {
-    #set _tool [Rappture::Tool ::#auto [Rappture::library $toolxml] \
-    #     [file dirname $toolxml]]
-    $this configure -test [$this cget -test]
 }
 