Index: trunk/packages/vizservers/nanovis/BucketSort.h
===================================================================
--- trunk/packages/vizservers/nanovis/BucketSort.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/BucketSort.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/CircularQueue.h
===================================================================
--- trunk/packages/vizservers/nanovis/CircularQueue.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/CircularQueue.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/Color.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/Color.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/Color.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/Color.h
===================================================================
--- trunk/packages/vizservers/nanovis/Color.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/Color.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/DataLoader.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/DataLoader.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/DataLoader.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/Event.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/Event.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/Event.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/Event.h
===================================================================
--- trunk/packages/vizservers/nanovis/Event.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/Event.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/ParticleEmitter.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/ParticleEmitter.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/ParticleEmitter.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/ParticleEmitter.h
===================================================================
--- trunk/packages/vizservers/nanovis/ParticleEmitter.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/ParticleEmitter.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/ParticleSystem.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/ParticleSystem.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/ParticleSystem.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/ParticleSystem.h
===================================================================
--- trunk/packages/vizservers/nanovis/ParticleSystem.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/ParticleSystem.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/PointShader.h
===================================================================
--- trunk/packages/vizservers/nanovis/PointShader.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/PointShader.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/ScreenSnapper.h
===================================================================
--- trunk/packages/vizservers/nanovis/ScreenSnapper.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/ScreenSnapper.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/Vector3.h
===================================================================
--- trunk/packages/vizservers/nanovis/Vector3.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/Vector3.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/datatype.h
===================================================================
--- trunk/packages/vizservers/nanovis/datatype.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/datatype.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/bandmat.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/bandmat.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/bandmat.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/cholesky.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/cholesky.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/cholesky.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/controlw.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/controlw.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/controlw.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/evalue.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/evalue.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/evalue.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/fft.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/fft.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/fft.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/hholder.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/hholder.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/hholder.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/include.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/include.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/include.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/jacobi.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/jacobi.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/jacobi.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/myexcept.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/myexcept.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/myexcept.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/myexcept.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/myexcept.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/myexcept.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newfft.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newfft.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newfft.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmat.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmat.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmat.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmat1.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmat1.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmat1.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmat2.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmat2.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmat2.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmat3.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmat3.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmat3.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmat4.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmat4.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmat4.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmat5.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmat5.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmat5.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmat6.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmat6.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmat6.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmat7.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmat7.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmat7.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmat8.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmat8.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmat8.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmat9.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmat9.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmat9.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmatap.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmatap.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmatap.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmatex.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmatex.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmatex.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmatio.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmatio.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmatio.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmatnl.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmatnl.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmatnl.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmatnl.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmatnl.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmatnl.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmatrc.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmatrc.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmatrc.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmatrm.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmatrm.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmatrm.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/newmatrm.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/newmatrm.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/newmatrm.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/nm_misc.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/nm_misc.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/nm_misc.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/precisio.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/precisio.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/precisio.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/solution.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/solution.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/solution.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/solution.h
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/solution.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/solution.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/sort.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/sort.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/sort.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/submat.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/submat.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/submat.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/newmat11/svd.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/newmat11/svd.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/newmat11/svd.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/particlemacro.h
===================================================================
--- trunk/packages/vizservers/nanovis/particlemacro.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/particlemacro.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/transfer-function/ColorGradient.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/transfer-function/ColorGradient.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/transfer-function/ColorGradient.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/transfer-function/ControlPoint.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/transfer-function/ControlPoint.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/transfer-function/ControlPoint.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/transfer-function/MainWindow.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/transfer-function/MainWindow.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/transfer-function/MainWindow.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/transfer-function/MainWindow.h
===================================================================
--- trunk/packages/vizservers/nanovis/transfer-function/MainWindow.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/transfer-function/MainWindow.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/transfer-function/TransferFunctionGLUTWindow.h
===================================================================
--- trunk/packages/vizservers/nanovis/transfer-function/TransferFunctionGLUTWindow.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/transfer-function/TransferFunctionGLUTWindow.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vr3d.h
===================================================================
--- trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vr3d.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vr3d.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture.h
===================================================================
--- trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture1D.h
===================================================================
--- trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture1D.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture1D.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture2D.h
===================================================================
--- trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture2D.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture2D.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture3D.h
===================================================================
--- trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture3D.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vr3d/include/vr3d/vrTexture3D.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vr3d/vr3d.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vr3d/vr3d.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vr3d/vr3d.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vr3d/vrTexture.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vr3d/vrTexture.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vr3d/vrTexture.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vr3d/vrTexture1D.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vr3d/vrTexture1D.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vr3d/vrTexture1D.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vr3d/vrTexture2D.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vr3d/vrTexture2D.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vr3d/vrTexture2D.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vr3d/vrTexture3D.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vr3d/vrTexture3D.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vr3d/vrTexture3D.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrBBox.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrBBox.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrBBox.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrBPlane.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrBPlane.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrBPlane.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrColor4f.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrColor4f.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrColor4f.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrLineSegment.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrLineSegment.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrLineSegment.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrLinmath.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrLinmath.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrLinmath.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrMatrix4x4f.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrMatrix4x4f.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrMatrix4x4f.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrPlane.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrPlane.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrPlane.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrPlane2.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrPlane2.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrPlane2.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrRotation.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrRotation.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrRotation.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrVector2f.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrVector2f.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrVector2f.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrVector3f.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrVector3f.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrVector3f.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrVector4f.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrVector4f.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/include/vrmath/vrVector4f.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/vrBBox.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrBBox.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrBBox.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/vrBPlane.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrBPlane.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrBPlane.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/vrColor4f.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrColor4f.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrColor4f.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/vrLineSegment.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrLineSegment.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrLineSegment.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/vrMatrix4x4f.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrMatrix4x4f.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrMatrix4x4f.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/vrPlane.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrPlane.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrPlane.cpp	(revision 2096)
@@ -11,3 +11,3 @@
 
     distance = m[12]*v.x + m[13]*v.y + m[14]*v.z + m[15]*v.w;
- }
+}
Index: trunk/packages/vizservers/nanovis/vrmath/vrPlane2.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrPlane2.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrPlane2.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/vrRotation.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrRotation.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrRotation.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/vrVector2f.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrVector2f.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrVector2f.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/vrVector3f.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrVector3f.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrVector3f.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrmath/vrVector4f.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/vrmath/vrVector4f.cpp	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrmath/vrVector4f.cpp	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrutil/include/vrutil/vrFilePath.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrutil/include/vrutil/vrFilePath.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrutil/include/vrutil/vrFilePath.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrutil/include/vrutil/vrStringParser.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrutil/include/vrutil/vrStringParser.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrutil/include/vrutil/vrStringParser.h	(revision 2096)
Index: trunk/packages/vizservers/nanovis/vrutil/include/vrutil/vrUtil.h
===================================================================
--- trunk/packages/vizservers/nanovis/vrutil/include/vrutil/vrUtil.h	(revision 2094)
+++ trunk/packages/vizservers/nanovis/vrutil/include/vrutil/vrUtil.h	(revision 2096)