Index: /branches/blt4/gui/scripts/datatable.tcl
===================================================================
--- /branches/blt4/gui/scripts/datatable.tcl	(revision 2286)
+++ /branches/blt4/gui/scripts/datatable.tcl	(revision 2287)
@@ -144,5 +144,5 @@
 	package require blt_datatable_csv
 	$d0 import csv -data $csvdata
-        for { set row 1 } { $row <= [$d0 row length] } { incr row } {
+        for { set row 1 } { $row <= [$d0 numrows] } { incr row } {
             set child [$_tree insert 0]
             set c 0 
Index: /branches/blt4/gui/scripts/datatableresult.tcl
===================================================================
--- /branches/blt4/gui/scripts/datatableresult.tcl	(revision 2286)
+++ /branches/blt4/gui/scripts/datatableresult.tcl	(revision 2287)
@@ -312,7 +312,4 @@
     }
     foreach col [$itk_component(treeview) column names] {
-        if { [string match "BLT TreeView*" $col] } {
-            continue
-        }
         $itk_component(treeview) column delete $col
     }
Index: /branches/blt4/gui/scripts/numberresult.tcl
===================================================================
--- /branches/blt4/gui/scripts/numberresult.tcl	(revision 2286)
+++ /branches/blt4/gui/scripts/numberresult.tcl	(revision 2287)
@@ -875,5 +875,5 @@
     set g $itk_component(plot)
     set elem ""
-
+  
     # Peek inside of Blt_ZoomStack package to see if we're currently in the
     # middle of a zoom selection.
@@ -882,10 +882,14 @@
     }
     set tip ""
+    set found 0
     if {$state == "at"} {
-        if {[$g element closest $x $y info -interpolate yes]} {
+        set results [$g element closest $x $y -interpolate yes]
+        if { $results != "" } {
+            array set info $results
             # for dealing with xy line plots
             set elem $info(name)
+
             # Some elements are generated dynamically and therefore will
-            # not have a data object associated with them.
+            # not have a dataobj object associated with them.
             set mapx [$g element cget $elem -mapx]
             set mapy [$g element cget $elem -mapy]
@@ -896,9 +900,15 @@
             # search again for an exact point -- this time don't interpolate
             set tip ""
-            if {[$g element closest $x $y info -interpolate no]
-                  && $info(name) == $elem} {
+            array unset info
+            set results [$g element closest $x $y -interpolate no]
+            array set info $results
+
+            if { [info exists info(name)] && $info(name) == $elem } {
+		set found 1
+
                 set x [$g axis transform $mapx $info(x)]
                 set y [$g axis transform $mapy $info(y)]
-
+                
+		set tip ""
                 if {[info exists _elem2dataobj($elem)]} {
                     set dataobj $_elem2dataobj($elem)
@@ -917,16 +927,26 @@
                 }
             }
-            set state 1
-        } elseif {[$g element closest $x $y info -interpolate no]} {
-            # for dealing with xy scatter plot
-            set elem $info(name)
-            foreach {mapx mapy} [GetAxes $_elem2dataobj($elem)] break
-
-            # search again for an exact point -- this time don't interpolate
-            set tip ""
-            if {$info(name) == $elem} {
+        } else { 
+            set results [$g element closest $x $y -interpolate no]
+            if { $results != ""  } {
+		set found 1
+
+                array unset info
+                array set info $results
+                # for dealing with xy scatter plot
+                set elem $info(name)
+                
+                # Some elements are generated dynamically and therefore will
+                # not have a dataobj object associated with them.
+                set mapx [$g element cget $elem -mapx]
+                set mapy [$g element cget $elem -mapy]
+                if {[info exists _elem2dataobj($elem)]} {
+                    foreach {mapx mapy} [GetAxes $_elem2dataobj($elem)] break
+                }
+                
+                set tip ""
                 set x [$g axis transform $mapx $info(x)]
                 set y [$g axis transform $mapy $info(y)]
-
+                
                 if {[info exists _elem2dataobj($elem)]} {
                     set dataobj $_elem2dataobj($elem)
@@ -945,11 +965,8 @@
                 }
             }
-            set state 1
-        } else {
-            set state 0
-        }
-    }
-
-    if {$state} {
+        }
+    }
+
+    if { $found } {
         #
         # Highlight ON:
@@ -958,5 +975,5 @@
         # - pop up tooltip about data
         #
-        if {$_hilite(elem) != "" && $_hilite(elem) != $elem} {
+        if { [$g element exists $_hilite(elem)] && $_hilite(elem) != $elem } {
             $g element deactivate $_hilite(elem)
             $g crosshairs configure -hide yes
@@ -966,14 +983,9 @@
         set _hilite(elem) $elem
 
-        set dlist [$g element show]
-        set i [lsearch -exact $dlist $elem]
-        if {$i >= 0} {
-            set dlist [lreplace $dlist $i $i]
-            lappend dlist $elem
-            $g element show $dlist
-        }
-
-        foreach {mapx mapy} [GetAxes $_elem2dataobj($elem)] break
-
+        set mapx [$g element cget $elem -mapx]
+        set mapy [$g element cget $elem -mapy]
+        if {[info exists _elem2dataobj($elem)]} {
+            foreach {mapx mapy} [GetAxes $_elem2dataobj($elem)] break
+        }
         set allx [$g x2axis use]
         if {[llength $allx] > 0} {
@@ -1042,23 +1054,22 @@
         # - take down tooltip
         #
-        if {"" != $_hilite(elem)} {
+        if { [$g element exists $_hilite(elem)] } {
             $g element deactivate $_hilite(elem)
-
-            set allx [$g x2axis use]
-            if {[llength $allx] > 0} {
-                lappend allx x  ;# fix main x-axis too
-                foreach axis $allx {
-                    $g axis configure $axis -color $itk_option(-foreground) \
-                        -titlecolor $itk_option(-foreground)
-                }
-            }
-
-            set ally [$g y2axis use]
-            if {[llength $ally] > 0} {
-                lappend ally y  ;# fix main y-axis too
-                foreach axis $ally {
-                    $g axis configure $axis -color $itk_option(-foreground) \
-                        -titlecolor $itk_option(-foreground)
-                }
+        }
+        set allx [$g x2axis use]
+        if {[llength $allx] > 0} {
+            lappend allx x  ;# fix main x-axis too
+            foreach axis $allx {
+                $g axis configure $axis -color $itk_option(-foreground) \
+                    -titlecolor $itk_option(-foreground)
+            }
+        }
+        
+        set ally [$g y2axis use]
+        if {[llength $ally] > 0} {
+            lappend ally y  ;# fix main y-axis too
+            foreach axis $ally {
+                $g axis configure $axis -color $itk_option(-foreground) \
+                    -titlecolor $itk_option(-foreground)
             }
         }
@@ -1071,5 +1082,5 @@
         }
 
-        # there is no currently highlighted element
+        # There is no currently highlighted element
         set _hilite(elem) ""
     }
@@ -1539,9 +1550,13 @@
 # ----------------------------------------------------------------------
 itcl::configbody Rappture::NumberResult::gridcolor {
-    if {"" == $itk_option(-gridcolor)} {
-        $itk_component(plot) grid off
+    if { "" == $itk_option(-gridcolor) } {
+        foreach axis [$itk_component(plot) axis names] { 
+            $itk_component(plot) axis configure $axis -grid off
+        }
     } else {
-        $itk_component(plot) grid configure -color $itk_option(-gridcolor)
-        $itk_component(plot) grid on
-    }
-}
+        foreach axis [$itk_component(plot) axis names] { 
+            $itk_component(plot) axis configure $axis \
+                -gridcolor $itk_option(-gridcolor) -grid on
+        }
+    }
+}
Index: /branches/blt4/gui/scripts/resultviewer.tcl
===================================================================
--- /branches/blt4/gui/scripts/resultviewer.tcl	(revision 2286)
+++ /branches/blt4/gui/scripts/resultviewer.tcl	(revision 2287)
@@ -350,5 +350,5 @@
                     set mode "number"
                     if {![info exists _mode2widget($mode)]} {
-p                        set w $itk_interior.number
+                        set w $itk_interior.number
                         Rappture::NumberResult $w
                         set _mode2widget($mode) $w