Index: trunk/packages/vizservers/configure
===================================================================
--- trunk/packages/vizservers/configure	(revision 2347)
+++ trunk/packages/vizservers/configure	(revision 2348)
@@ -8175,4 +8175,7 @@
   fi
 done
+if test "x${DX_INC_DIR}" = "x" ; then
+  as_fn_error $? "cannot find OpenDX include files" "$LINENO" 5
+fi
 
 if test "${DX_INC_DIR}" = "/usr/include" ; then
@@ -8245,4 +8248,7 @@
   fi
 done
+if test "x{$DX_LIB_DIR}" = "x" ; then
+  as_fn_error $? "cannot find OpenDX libraries" "$LINENO" 5
+fi
 
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for libDXcallm library" >&5
@@ -8575,4 +8581,6 @@
 _ACEOF
 
+else
+  as_fn_error $? "cannot find nVidia Cg headers" "$LINENO" 5
 fi
 
@@ -8619,5 +8627,5 @@
 
 
-ac_config_files="$ac_config_files Makefile nanoscale/Makefile nanovis/Makefile nanovis/newmat11/Makefile nanovis/R2/src/Makefile nanovis/vrutil/Makefile nanovis/vrmath/Makefile nanovis/vr3d/Makefile nanovis/imgLoaders/Makefile nanovis/transfer-function/Makefile pymolproxy/Makefile vtkvis/Doxyfile vtkvis/Makefile start_viz.sh"
+ac_config_files="$ac_config_files Makefile nanoscale/Makefile nanoscale/renderservers.tcl nanovis/Makefile nanovis/newmat11/Makefile nanovis/R2/src/Makefile nanovis/vrutil/Makefile nanovis/vrmath/Makefile nanovis/vr3d/Makefile nanovis/imgLoaders/Makefile nanovis/transfer-function/Makefile pymolproxy/Makefile vtkvis/Doxyfile vtkvis/Makefile start_viz.sh start_nanoscale.sh"
 
 cat >confcache <<\_ACEOF
@@ -9329,4 +9337,5 @@
     "Makefile") CONFIG_FILES="$CONFIG_FILES Makefile" ;;
     "nanoscale/Makefile") CONFIG_FILES="$CONFIG_FILES nanoscale/Makefile" ;;
+    "nanoscale/renderservers.tcl") CONFIG_FILES="$CONFIG_FILES nanoscale/renderservers.tcl" ;;
     "nanovis/Makefile") CONFIG_FILES="$CONFIG_FILES nanovis/Makefile" ;;
     "nanovis/newmat11/Makefile") CONFIG_FILES="$CONFIG_FILES nanovis/newmat11/Makefile" ;;
@@ -9341,4 +9350,5 @@
     "vtkvis/Makefile") CONFIG_FILES="$CONFIG_FILES vtkvis/Makefile" ;;
     "start_viz.sh") CONFIG_FILES="$CONFIG_FILES start_viz.sh" ;;
+    "start_nanoscale.sh") CONFIG_FILES="$CONFIG_FILES start_nanoscale.sh" ;;
 
   *) as_fn_error $? "invalid argument: \`$ac_config_target'" "$LINENO" 5;;
Index: trunk/packages/vizservers/configure.in
===================================================================
--- trunk/packages/vizservers/configure.in	(revision 2347)
+++ trunk/packages/vizservers/configure.in	(revision 2348)
@@ -358,4 +358,5 @@
   Makefile \
    nanoscale/Makefile \
+   nanoscale/renderservers.tcl \
    nanovis/Makefile \
    nanovis/newmat11/Makefile \
Index: trunk/packages/vizservers/nanoscale/renderservers.tcl.in
===================================================================
--- trunk/packages/vizservers/nanoscale/renderservers.tcl.in	(revision 2348)
+++ trunk/packages/vizservers/nanoscale/renderservers.tcl.in	(revision 2348)
@@ -0,0 +1,31 @@
+
+set exec_prefix "@exec_prefix@"
+set bindir "@bindir@"
+set libdir "@libdir@"
+set vtkdir "@VTK_LIB_DIR@"
+
+# NanoVis server --
+#
+register_server nanovis 2000 {
+    ${bindir}/nanovis -p ${libdir}/shaders:${libdir}/resources
+} {
+  LD_LIBRARY_PATH ${libdir}
+}
+
+# VtkVis server --
+#    3D drawings (scene graphs), Contour and surface graphs.
+#
+register_server vtkvis 2010 {
+    ${bindir}/vtkvis
+} {
+  LD_LIBRARY_PATH ${libdir}:${vtkdir}
+}
+
+# Pymol server --
+#    Molecular layouts from PDB description.  Must set PYMOL_PATH.
+#    
+register_server pymol 2020 {
+    ${bindir}/pymolproxy ${bindir}/pymol -p -q -i -x -X 0 -Y 0
+} {
+   PYMOL_PATH ${libdir}/pymol
+}
Index: trunk/packages/vizservers/start_nanoscale.sh.in
===================================================================
--- trunk/packages/vizservers/start_nanoscale.sh.in	(revision 2347)
+++ trunk/packages/vizservers/start_nanoscale.sh.in	(revision 2348)
@@ -27,5 +27,5 @@
 cd /tmp
 
-exec ${bindir}/nanoscale -x ${numVideo} -f ${libdir}/renderservers.tcl
+exec ${bindir}/nanoscale -x ${numVideo} 
 
 
Index: trunk/packages/vizservers/vtkvis/Makefile.in
===================================================================
--- trunk/packages/vizservers/vtkvis/Makefile.in	(revision 2347)
+++ trunk/packages/vizservers/vtkvis/Makefile.in	(revision 2348)
@@ -32,5 +32,5 @@
 VTK_INC_SPEC	= @VTK_INC_SPEC@
 
-LD_RUN_PATH	= $(VTK_LIB_DIR):($(libdir)
+LD_RUN_PATH	= $(VTK_LIB_DIR):$(libdir)
 
 LIBS		= \